#!/usr/bin/env python2

import quipple.parse,quipple.query

qs=list(quipple.parse.parse('francis.quo'))

query=quipple.query.Query(words=['recursion','problem','for','an'])
found=list(query.search(qs))

q26="Recursion is easy.  You take a big problem, break off a manageable chunk, and are left with a bigger chunk."
q36="The problem with unwritten laws is that they're so hard to erase."
q46="One must understand recursion to understand recursion.   To understand tail recursion, one must understand tail recursion."

assert(list(map(lambda q: q.flatten(),found))==[q26,q46,q36])

query=quipple.query.Query(words=['recursion','problem'],max=2)
found=list(query.search(qs))
assert(list(map(lambda q: q.flatten(),found))==[q26,q46])

query=quipple.query.Query(words=['recursion','problem'],max=2,shuffle=3)
for i in range(0,10):
    found=list(query.search(qs))
    assert(len(found)==2)
    assert(set(map(lambda q: q.flatten(),found)).issubset(set([q26,q46,q36])))

query=quipple.query.Query(tags=['work'])
found=list(query.search(qs))
print(len(found))
assert(len(found)==59)
