#!/usr/bin/env python2

import quipple.source,quipple.query

francis=quipple.source.XmlSource(('filename','francis.quo'))
francisQ=francis.filter(quipple.query.Query(words=['problem'],
                                            tags=['work']))
sample=quipple.source.XmlSource(('filename','sample.quo'))
agg=quipple.source.Aggregator([francisQ,sample])

q26="Recursion is easy.  You take a big problem, break off a manageable chunk, and are left with a bigger chunk."
q36="The problem with unwritten laws is that they're so hard to erase."
q397="DRM: a booted foot stomping on an unprotected screen, forever."

assert(list(map(lambda q: q.flatten(),francisQ.all()))==[q36,q26])
assert(list(map(lambda q: q.flatten(),sample.all()))==[q397])
assert(list(map(lambda q: q.flatten(),agg.all()))==[q36,q26,q397])

print(agg.toXML())
